package xyz.lychee.lagfixer.hooks;

import com.craftaro.ultimatestacker.api.UltimateStackerApi;
import com.craftaro.ultimatestacker.api.stack.item.StackedItem;
import java.util.List;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.HookManager;
import xyz.lychee.lagfixer.managers.SupportManager;
import xyz.lychee.lagfixer.objects.AbstractHook;
import xyz.lychee.lagfixer.objects.AbstractStacker;

public class UltimateStackerHook extends AbstractHook {
   private static UltimateStackerHook instance;

   public UltimateStackerHook(LagFixer plugin, HookManager manager) {
      super(plugin, manager);
      instance = this;
   }

   public void load() {
      SupportManager.getInstance().setStacker(new StackerImplementation());
   }

   public void disable() {
   }

   public String plugin() {
      return "UltimateStacker";
   }

   public static UltimateStackerHook getInstance() {
      return instance;
   }

   public static class StackerImplementation extends AbstractStacker {
      public void addItemsToList(Item bItem, List<ItemStack> items) {
         StackedItem item = UltimateStackerApi.getStackedItemManager().getStackedItem(bItem);
         if (!item.isValid()) {
            items.add(bItem.getItemStack());
         } else {
            ItemStack is = bItem.getItemStack();
            int amount = item.getAmount();
            int max = is.getMaxStackSize();
            if (amount <= max) {
               ItemStack clone = is.clone();
               clone.setAmount(amount);
               items.add(clone);
            } else {
               for(int i = amount; i > 0; i -= max) {
                  ItemStack clone = is.clone();
                  clone.setAmount(Math.min(i, max));
                  items.add(clone);
               }
            }

         }
      }
   }
}
